<?php

// Picscript 1.7
// Written by Mark Kamichoff <prox@penguinhosting.net>

$version = "1.7";

// Initialize some global-ish vars
$descriptions=array();
$title="(error opening var/descriptions.txt)";
$default_descriptions=1;

$numfiles=-1;
$files=array();

function read_the_dir() {
	global $files, $numfiles;

	// Read all jpg and png files in, now
	if($dh = opendir(".")) {
//		$files = array();
	
		while(false !== ($file = readdir($dh))) {
			if(preg_match("/.+\.jpg/", $file) ||
					preg_match("/.+\.png/", $file)) {
				array_push($files, $file);
			}
		}
	
		$numfiles = count($files);
	
		closedir($dh);
	} else {
		print "Error opening directory.";
		die;
	}
}

function do_cookies() {
	// Mess with cookies, first
	if($_REQUEST['npp'] > 0) {	// If we specified
		// Save the cookie
		setcookie("ProlixiumPicscriptNPP", $_REQUEST['npp'],
				time()+86400);	// Expire in 24 hours
		// Set the var
		$npp = $_REQUEST['npp'];
	} else if($_COOKIE['ProlixiumPicscriptNPP']) {	// We got a cookie
		// Set the var
		$npp = $_COOKIE['ProlixiumPicscriptNPP'];
	} else {
		// Fall back to default
		$npp = 15;
	}

	return $npp;
}

function end_page($npp,$numfiles,$version) {
	print "<hr />\n";
	
	print "<form method=\"post\">\n";
	print "<table style=\"width: 100%\">";
	print "\n<tr><td class=\"red\" style=\"width: 30%\">";
	
	print "<a href=\"";
	if($_REQUEST['image']) {
//		print $_SERVER['HTTP_REFERER'];
		preg_match("/([^\?]+).*/",$_SERVER['REQUEST_URI'],
				$matches);
		print $matches[1];
		print "\">Back to gallery</a>";
	} else {
		print "../";
		print "\">Up one directory</a>";
	}
	print "</td>\n";
	
	print "<td class=\"grey\" style=\"text-align: center; vertical-align: middle; width: 40%\">";
	
	// Display small form, to set $npp
	print "Display <input type=\"text\" name=\"npp\" value=\"$npp\">
	pictures per page.\n";
	// print "<input type=\"submit\" name=\"submit\" value=\"Save\">\n";
	
	print "</td>\n";
	
	print "<td class=\"red\" style=\"text-align: right; width: 30%\">";
	print $numfiles;
	print " pictures in gallery, via <a
	href=\"http://www.prolixium.com/coding/picscript/\">picscript</a>
	$version";
	print "</td></tr></table>";
	print "</form>\n";
	
	print "\n</body></html>";
}

function read_descriptions() {
	// Open the file, optionally
	// File has format like this:
	// -----------------------------------------------------
	// Title of photo album
	// (default_descriptions|no_default_descriptions)
	// photo.jpg,description of photo.jpg
	// photo2.jpg,description of photo2.jpg
	// [etc...]
	// -----------------------------------------------------
	// Reads it into an array, and stuff

	global $descriptions, $title, $default_descriptions;

	if($fd = fopen("var/descriptions.txt", 'r')) {
	
		// Title
		$title = rtrim(fgets($fd));
		if(rtrim(fgets($fd)) == "default_descriptions") {
			$default_descriptions=1;
		} else {
			$default_descriptions=0;
		}
		
		while($line = fgets($fd)) {
			if(preg_match("/([^,]+),(.+)/", $line, $matches)) {
				$descriptions[$matches[1]] = $matches[2];
			}
		}
	
		fclose($fd);
	}
}

// Read the dir, get $numfiles and $files
read_the_dir();

// Do cookies!
$npp = do_cookies();

// Check if we're supposed to display an individual image
if($_REQUEST['image']) {

	read_descriptions();
	print <<<EOT
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html 
     PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">

EOT;

	// Do the stuff
	$file_name=$files[$_REQUEST['image']-1];

	print "<head>\n";
	print "<link rel=\"stylesheet\" type=\"text/css\" href=\"lib/dark.css\" title=\"Dark\" />\n";
	print "<title>";
	print "$title - ";
	if($descriptions[$file_name]) {
		print $descriptions[$file_name];
	} else {
		print $file_name;
	}
	print "</title>\n";
	print "</head>\n";

	print "<table style=\"width: 100%; margin-left: auto; margin-right: auto\">\n";
	print "<tr>\n";
	print "<td style=\"text-align: center; vertical-align: middle; width: 10%\">";
	if($_REQUEST['image']) {
//		print $_REQUEST['image']-1;
		print "<a href=\"?image=".($_REQUEST['image']-1)."\"><img src=\"lib/prev.png\"
				alt=\"Previous Image\"></a>\n";
	} else {
		print "&nbsp;";
	}
	print "</td>\n";
	
	print "<td style=\"vertical-align: middle; text-align: center; width: 80%\">\n";
	print "<font style=\"font-size: 24px\">";
	print "$title - ";
	if($descriptions[$file_name]) {
		print $descriptions[$file_name];
	} else {
		print $file_name;
	}
	print "</font>\n";
	print "</td>\n";
	
	print "<td style=\"text-align: center; vertical-align: middle; width: 10%\">";
	if($_REQUEST['image']+1 == count($files)) {
		print "&nbsp;";
	} else {
//		print $_REQUEST['image']+1;
		print "<a href=\"?image=".($_REQUEST['image']+1)."\"><img src=\"lib/next.png\"
				alt=\"Next Image\"></a>\n";
	}

	print "</td>\n";
	print "</tr>\n";
	print "</table>\n";

	// Yep
	print "<hr />\n";

	print "<p style=\"text-align: center\">\n";

	// Static image
	print "<a href=\"{$file_name}\"><img
src=\"previews/{$file_name}\" alt=\"Click for full-size
{$file_name}\"></a>\n";

	print "</p>\n";
	
	// All done
	end_page($npp,$numfiles,$version);
} else { 
	
	function xmlheading($title, $pagenum, $maxpage) {
		print <<<EOT
	<?xml version="1.0" encoding="UTF-8"?>
	<!DOCTYPE html 
	     PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
	    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
	<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
	
EOT;
	
		print "<head>\n";
	
		print "<link rel=\"stylesheet\" type=\"text/css\" href=\"lib/dark.css\" title=\"Dark\" />\n";
	
		print "<title>";
		print $title." (Page $pagenum/$maxpage)";
		print "</title>\n";
		print "</head>\n";
	
		print "<body>\n";
	
	//	print "<h2>$title [Page $pagenum/$maxpage]</h2>\n";
	}
	
	read_descriptions();

	// Page number, optional
	$page = 0;
	if($_REQUEST['page']) {
		if($_REQUEST['page']-1 > 0) {
			// This used to be <=
			if(($_REQUEST['page']-1)*$npp < $numfiles) {
				$page = $_REQUEST['page']-1;
			}
		}
	}
	
	// Do heading, now
	$maxpage=ceil($numfiles/$npp);
	xmlheading($title, $page+1, $maxpage);
	
	print "<table style=\"width: 100%; margin-left: auto; margin-right: auto\">\n";
	
	print "<tr>\n";
	print "<td style=\"text-align: center; vertical-align: middle; width: 20%\">\n";
	
	if($page != 0) {
		print "<a href=\"?page=".($page)."\"><img src=\"lib/prev.png\"
	alt=\"Previous Page\"></a>\n";
	} else {
		print "&nbsp;";
	}
	
	print "</td>\n";
	
	print "<td style=\"vertical-align: middle; text-align: center; width: 60%\">\n";
	print "<font style=\"font-size: 24px\">$title (Page
	".($page+1)."/$maxpage)</font>\n";
	print "</td>\n";
	
	print "<td style=\"text-align: center; vertical-align: middle; width: 20%\">\n";
	
	if(($npp*($page+1) <= $numfiles) && ceil($numfiles/$npp) > $page+1) {
		print "<a href=\"?page=".($page+2)."\"><img
	src=\"lib/next.png\" alt=\"Next Page\"></a>\n";
	} else {
		print "&nbsp;";
	}
	
	print "</td>\n";
	print "</tr>\n";
	
	print "</table>\n";
	
	// Yep
	print "<hr />\n";
	
	// Some conditions
	if($npp*($page+1) > $numfiles) {
		$max = $numfiles;
	} else {
		$max = ($npp)*($page+1);
	}
	
	// Display table, will do CSS and stuff later
	print "<table style=\"width: 100%\">\n";
	print "<tr>\n";
	
	for($numb = $page*$npp; $numb < $max; $numb++) {
		if(!(($numb-($page*$npp))%5) && $numb!=$page*$npp) {
			print "</tr>\n";
			print "<tr>\n";
		}
	
	//	print "<td valign=\"top\" width=\"20%\">\n";
		print "<td class=\"thumb\" style=\"text-align: center; vertical-align: top; width: 20%\">\n";
		print "\t<a href=\"";
		
		// This will allow us to do next/prev on the individual
		// image page
//		print "?image=".$files[$numb];
		print "?image=".($numb+1);
	
		print "\">\n";
		print "\t\t<img src=\"thumbs/";
		print $files[$numb];
		print "\" alt=\"";
	
		// Alt
		print $files[$numb];
	
		print "\"></a>\n\t<hr width=\"50%\" />\n\t<font style=\"font-style: italic\">";
	
		// Description
		if($descriptions[$files[$numb]]) {
			print $descriptions[$files[$numb]];
		} else {
			if($default_descriptions) {
				print $files[$numb];
			} else {
				print "No label";
			}
		}
	
		print "</font>\n";
		print "</td>\n\n";
	}
	
	print "</tr>\n";
	
	print "</table>\n";

	end_page($npp,$numfiles,$version);
}

?>
